// Better Base64 app for Windows96

class App extends w96.WApplication {
	constructor() {
		super();
	}
	async main(argv) {
		super.main(argv);
		const win = this.createWindow({
			title: "Better Base64",
			body: `
                <div style="display: flex; align-items: center; height: 100%; width: 100%;">
                    <img src="https://windows96.net/system/resource/themes/default/icons/apps/base64.png">
                    <div style="flex: 1; margin-left: 2px;">
                        <div id="text" class="input" style="display: flex; width: 100%; margin-bottom: 2px;">
                            <input id="textinput" class="w96-textbox" style="flex: 1;">
                            <button id="encode" class="w96-button" style="margin-left: 2px;">Encode</button>
                        </div>
                        <div id="base" class="input" style="display: flex; width: 100%;">
                            <input id="baseinput" class="w96-textbox" style="flex: 1;">
                            <button id="decode" class="w96-button" style="margin-left: 2px;">Decode</button>
                        </div>
                    </div>
                </div>
                <audio id="ding">
                    <source src="https://windows96.net/system/resource/sounds/ding.mp3" type="audio/mp3">
                </audio>
            `,
			initialHeight: 67,
			initialWidth: 400,
			taskbar: true,
			icon: w96.ui.Theme.getIconUrl("apps/base64")
		}, true);
        const body = win.getBodyContainer();
        const basein = body.querySelector("#baseinput");
        const textin = body.querySelector("#textinput");
        const ding = body.querySelector("#ding");
        body.querySelector("#encode").addEventListener("click", () => {
            basein.value = btoa(unescape(encodeURIComponent(textin.value)));
            ding.currentTime = 0;
            ding.play();
        })
        body.querySelector("#decode").addEventListener("click", () => {
            textin.value = decodeURIComponent(escape(atob(basein.value)));
            ding.currentTime = 0;
            ding.play();
        })
		win.show();
	}
}

registerApp("bbase64", [], function(args) {
	return w96.WApplication.execAsync(new App(), args);
});

u96.shell.mkShortcut("c:/system/programs/Utility/Better Base64.link", "apps/base64", "bbase64");